<?php

namespace App\DataTables;

use App\Models\Testi;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class TestiDataTableEditor extends DataTablesEditor
{
  protected $model = Testi::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'titolo.required' => 'Il titolo è richiesto',
    'descrizione.required' => 'La descrizione è richiesta',
    'testo.required' => 'Il testo è richiesto',
    'ambiente.required' => 'L\'ambiente è richiesto',
    'tipo.required' => 'Il tipo è richiesto',
    'is_attivo.required' => 'Indicare una delle due opzioni',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'titolo'  => 'required',
      'attivita_id' => 'required|exists:attivita,id',
      'descrizione' => 'nullable',
      'testo' => 'nullable',
      'ambiente' => 'nullable',
      'tipo' => 'nullable',
      'is_attivo' => 'boolean',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'titolo'  => 'required',
      'attivita_id' => 'required|exists:attivita,id',
      'descrizione' => 'nullable',
      'testo' => 'nullable',
      'ambiente' => 'nullable',
      'tipo' => 'nullable',
      'is_attivo' => 'boolean',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    $data['is_attivo'] = isset($data['is_attivo']) ? true : false;
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
